import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.*;  //Scene
import javafx.scene.layout.*;  //Pane
import javafx.scene.input.*; //MouseEvent
import javafx.scene.canvas.*;  //Canvas, GraphicsContext
import javafx.scene.control.*;  //RadioButton
import javafx.scene.paint.Color;
import javafx.geometry.*;  //Pos


public class Fractal extends Application {
    RadioButton red, blue, both;
    GraphicsContext gc;

    int which;           // WI{^łǂꂪIĂ邩oĂ
    int n = 15;          // JԂ
    double m = 200;      // 1ӂ̒
    double XA = m, YA = m*2, XB = m*2, YB=m*2;
    double xxa = m + m/2, yya = 2*m-m/2;
    double xxb = m + m/2, yyb = 2*m-m/2;
    final double W = m * 3, H = m * 3;
    double sina, cosa, sinb, cosb;

    @Override
    public void start(Stage stage) {
	    //`
        Canvas canvas = new Canvas(W, H);
        gc = canvas.getGraphicsContext2D();
        //WI{^
        HBox control = new HBox();
        red = new RadioButton("");  
        blue = new RadioButton("");  
        both = new RadioButton("");
        ToggleGroup group = new ToggleGroup();
        red.setToggleGroup(group);
        blue.setToggleGroup(group);
        both.setToggleGroup(group);
        both.setSelected(true);
        control.setAlignment(Pos.CENTER);
        control.setSpacing(50);
        control.getChildren().addAll(red, blue, both); 
		//Ŝ̃Rei
		VBox root = new VBox();
        root.getChildren().addAll(canvas, control);
        root.setStyle("-fx-background-color: white");
        control.setStyle("-fx-background-color: aliceblue");
        drawit();
		Scene scene = new Scene(root);
        stage.setTitle("Fractal");
        stage.setScene(scene);
        stage.show();
		
        canvas.setOnMousePressed((MouseEvent e) -> {
                setvariables(e);
                drawit();
            });
        canvas.setOnMouseDragged((MouseEvent e) -> {
                setvariables(e);
                drawit();
            });
    }
    void setvariables(MouseEvent e){
        if(red.isSelected()) which = 1;
        if(blue.isSelected()) which = 2;
        if(both.isSelected()) which = 3;

        if(which == 1 || which == 3){
            xxa = e.getX();
            yya = e.getY();
        }
        if(which == 2 || which == 3){
            xxb = e.getX();
            yyb = e.getY();
        }
    }


    
    void drawit(){
        gc.clearRect(0, 0, gc.getCanvas().getWidth(), gc.getCanvas().getHeight());
        sina = (double)(yya - YA)/m;
        cosa = (double)(xxa - XA)/m;
        sinb = (double)(yyb - YB)/m;
        cosb = (double)(xxb - XB)/m;
        gc.setStroke(Color.BLACK);
        levi(XA,YA,XB,YB,n);

        gc.setFill(Color.SKYBLUE); gc.fillOval(xxb-2,yyb-2,6,6);
        gc.setFill(Color.RED); gc.fillOval(xxa-2,yya-2,6,6);
        gc.setFill(Color.LIME); gc.fillOval(XA-2,YA-2,6,6);
        gc.setFill(Color.LIME); gc.fillOval(XB-2,YB-2,6,6);
    }

    void levi(double x1, double y1, double x2, double y2, int n){
        if(n == 0){
            gc.strokeLine(x1, y1, x2, y2);
        }else{
            double x3 = x1 + (x2-x1)* cosa - (y2-y1)*sina;
            double y3 = y1 + (y2-y1)* cosa + (x2-x1)*sina;
            double x4 = x2 + (x2-x1)* cosb -(y2-y1)* sinb;
            double y4 = y2 + (y2-y1)* cosb + (x2-x1)*sinb;
            levi(x1, y1, x3,y3, n-1);
            levi(x4, y4, x2,y2, n-1);
        }
    }

    public static void main(String... args) {
        launch(args);
    }    
}
