// ؂̃tN^
import javafx.application.Application;
import javafx.stage.Stage;
import javafx.scene.*;  //Scene
import javafx.scene.control.*;   // Button, Label
import javafx.scene.layout.*;  // VBox, HBox 
import javafx.event.*;  //ActionEvent
import javafx.scene.input.*; //MouseEvent
import javafx.scene.paint.*; //Color
import javafx.scene.canvas.*;  //Canvas, GraphicsContext
import javafx.geometry.*;   // Pos

public class TreeChange extends Application {
	Canvas canvas;
	final double W = 400, H = 400;
	double scale = 0.7;  //}̒ZȂ䗦
	double angle = 30; //}̍L
	double len = 110;  //ŏ̎}̒
	int N = 8; //}ʂ̒i

	@Override
    public void start(Stage stage) {
		//XChRei
		//pxpXC_[
		Slider sliderA = new Slider(0, 100, angle);
		sliderA.setShowTickLabels(true);
		sliderA.setShowTickMarks(true);
		sliderA.setPrefWidth(200);
		Label labelA = new Label(String.format("%.2f", angle));
		HBox paneA = new HBox();
		paneA.setPadding(new Insets(30, 10, 10, 30));
		paneA.setSpacing(20);
		paneA.getChildren().addAll(new Label("px@@@"), sliderA, labelA);
		paneA.setStyle("-fx-background-color:#ffffff");
		//}̔䗦pXC_[
		Slider sliderR = new Slider(0, 1, scale);
		sliderR.setShowTickLabels(true);
		sliderR.setShowTickMarks(true);
		sliderR.setMajorTickUnit(0.2);
		sliderR.setPrefWidth(200);
		Label labelR = new Label(String.format("%.2f", scale));
		HBox paneR = new HBox();
		paneR.setPadding(new Insets(10, 10, 10, 30));
		paneR.setSpacing(20);
		paneR.getChildren().addAll(new Label("}̔䗦"),sliderR, labelR);
		paneR.setStyle("-fx-background-color:#ffffff");
		//2̃XC_̂
		VBox lowerPane = new VBox();
		lowerPane.getChildren().addAll(paneA, paneR);
		//㕔Rei
		Pane upperPane = new Pane();
		canvas = new Canvas(W, H);
		upperPane.getChildren().add(canvas);
        drawCanvas();
		//S̔zu
		VBox root = new VBox();
		root.getChildren().addAll(upperPane, lowerPane);
        Scene scene = new Scene(root);
		stage.setTitle("Tree with slider");
		stage.setScene(scene);
		stage.sizeToScene();
		stage.show();
		
		//Cxg@XC_[ω烉x̒lύX
		sliderA.valueProperty().addListener((ov, oldValue, newValue) -> {  //Xi[̎w
			angle = newValue.doubleValue();
			labelA.setText(String.format("%.2f", angle));
			drawCanvas();
        });
		sliderR.valueProperty().addListener((ov, oldValue, newValue) -> {  //Xi[̎w
			scale = newValue.doubleValue();
			labelR.setText(String.format("%.2f", scale));
			drawCanvas();
        });
    }

	void drawCanvas() {
		GraphicsContext gc = canvas.getGraphicsContext2D();
		gc.setStroke(Color.rgb(100, 153, 0, 1));
		gc.setFill(Color.WHITE);
		gc.fillRect(0, 0, W, H);
		drawTree(gc, W/2, H, len, 0, N);
    }
	
	void drawTree(GraphicsContext gc, double x1, double y1, double len , double stand, int n){
		double x2= x1 + len*Math.sin(Math.toRadians(stand));  //}xW
		double y2= y1 - len*Math.cos(Math.toRadians(stand));
		gc.strokeLine(x1, y1, x2, y2);
		if (n >= 1) {  
			drawTree(gc, x2, y2, len*scale, stand-angle, n-1); //̍̎}`
			drawTree(gc, x2, y2, len*scale, stand+angle, n-1); //̉E̎}`
		}
	}

	public static void main(String... args) {
		launch(args);
	} 
}