import javafx.application.Application;
import javafx.scene.*;  //Scene
import javafx.stage.Stage;
import javafx.scene.layout.*;   //Pane
import javafx.scene.shape.*;  //Circle
import javafx.scene.paint.*; //Color
import javafx.animation.*; //Transition
import javafx.util.*;      //Duration

public class TimelineExample extends Application {
	Pane root;
	Circle cir;
    double w=400, h=400;
    @Override
    public void start(Stage stage) {
		root = new Pane();
		root.setPrefSize(w, h);
        Scene scene = new Scene(root);
        makeShapes();
        stage.setTitle("Timeline Example");
        stage.setScene(scene);
        stage.show();
    }
	
	void makeShapes() {
		cir = new Circle(w/2, h/2, 5);
		root.getChildren().add(cir);
		Timeline tline = new Timeline(  //3̃L[t[ݒ
			new KeyFrame(Duration.ZERO, new KeyValue(cir.radiusProperty(), 5),
						new KeyValue(cir.fillProperty(), Color.WHITE)),
			new KeyFrame(Duration.millis(1000), //Pb̃t[ChF
						new KeyValue(cir.fillProperty(), Color.YELLOW)),
			new KeyFrame(Duration.millis(2000), //2b̃t[ChԁCaw/2(200)
						new KeyValue(cir.radiusProperty(), w/2, Interpolator.EASE_IN),
						new KeyValue(cir.fillProperty(), Color.RED))
		);
		tline.setCycleCount(Animation.INDEFINITE);
		tline.setAutoReverse(true);
		tline.play();
    }

    public static void main(String... args) {
        launch(args);
    }    
}
